Index: /trunk/SophyaLib/Manual/perfmachine.txt
===================================================================
--- /trunk/SophyaLib/Manual/perfmachine.txt	(revision 3243)
+++ /trunk/SophyaLib/Manual/perfmachine.txt	(revision 3244)
@@ -7,6 +7,9 @@
 (a) eros3 : Bipro-bicoeur Xeon@2.4 GHz Linux (xeon-lx-2.4GHz)  , gcc 3.2
 (b) ccali : Bipro-bicoeur Xeon@2.8 GHz Linux (xeon-lx-2.8GHz)  , icc 8.0 ou 9.0
+     Flags de compilation avec [-O -g]      
 (c) sgsda: AMD Bipro AMD opteron 248 @ 2.2 GHz (amd-lx-
+     Flags de compilation avec [-O -g]      
 (cc) grid-saclay: AMD opteron 275 Bipro-bicoeur  @ 2.2 GHz (amd275-lx)
+     Flags de compilation avec [-O -g]      
 
 (d) asc: bipro alpha (@ ~1 GHz) server DS20 OSF (osf1)  , cxx 6.5 (osf-asc)
@@ -32,7 +35,15 @@
 - Effet du systeme ou carte mere ??? 
 
-
-Donnees SPECint2000 (3) / SPECfp2000 (2) (http//www.spec.org)
-(1) MFLOPS  -> cpupower 2   (x/y : -O -g / -O3)
+Flag de compilation 
+- Flag de compilation par defaut [-O -g] en general
+- Sur eros3 (xeon-linux gcc 3.3) [-O -g] OU [-O3 -g]
+- Sur Darwin [-g] ou [-O2 -g] (ou [-tune G5] sur XServe G5)
+   Sur les mac (en particulier G4/G5), grande difference entre -g et -Ox -g
+   mais peu de difference entre -O -O2 -O3  
+- Sur machine aix-meso [-O -g] ou [-O3 -g]
+
+X/ Donnees SPECint2000 (3) / SPECfp2000 (2) (http//www.spec.org)
+
+(1) MFLOPS  -> cpupower 2   (x/y : -O -g / -O3)  
 ----------------------------------------------------------------------
                          MFLOPS(1)      SPECfp      SPECint 
@@ -45,9 +56,10 @@
 (f)superosf               842            1100         700
 
-(i)core-osx-1.83GHz       855            1400        1500
+(f)G4-osx-1.25GHz      92/380                                 (-g)/(-O2 -g)
+(i)core-osx-1.83GHz    310/880            1400        1500    (-g)/(-O2 -g)
 (j)xeon-osx              2600            2900          -
 
-(p)ibm-aix-regatta    730/1750           1050         700
-(p)ibm-aix-meso      1250/3600         
+(p)ibm-aix-regatta    730/1750           1050         700     (-O -g)/(-O3)
+(p)ibm-aix-meso      1250/3600                                (-O -g)/(-O3)
 ----------------------------------------------------------------------
 
@@ -76,5 +88,6 @@
 (f)superosf (1)          895 s      112       910 s        98%
 
-(f)G4-osx-1.25GHz (1)    660 s      151       710 s        93%
+(f)G4-osx-1.25GHz (1)    660 s      151       710 s        93%   [-g]
+                        1500 s                             94%   [-O2 -g]
 (h)G5-osx-1GHz (2)       453 s      221       250 s        182%
     -tune=G5            1100 s       90
@@ -95,5 +108,5 @@
 --------------------------------------------------------
 
-B.1/ arr = c1*a1+c2*a2
+B.1/ arr = c1*a1+c2*a2   ( ~ 3 10^6 op. double)
 (1) time cpupower 2     # compile avec -O3  (/ -O -g)
 (2) time zthr arr 1 1000   1 thread
@@ -126,12 +139,13 @@
                                            (4)11.6/3.06/379%          
 
-(f)G4-osx-1.25GHz      333        44s/48s/91%              86.7/99.8/92%
+(f)G4-osx-1.25GHz       92        44s/48s/91%              86.7/99.8/92%  [-g]
+                       380        12.2/12.9/95%            24/25.3/95%    [-O2 -g]                   
 (h)G5-osx-1GHz        1151        20s/20s/99%              40s/23s/170%
                                            (4) 80.8/45/180%
    -tune=G5                       3.35/3.8/88%             7.1/3.6/196%
                                            (4) 14/7.5/187%
-(i)core-osx-1.83GHz    855        11.5/11.5/100%           23/11.6/192%
+(i)core-osx-1.83GHz    855        11.5/11.5/100%           23/11.6/192%   [-g]
                                            (4) 46/23/199%
-              -O2                 3.85/3.89/99%            7.7/3.9/198%
+              -O2                 3.85/3.89/99%            7.7/3.9/198%   [-O2 -g]
                                            (4) 15.4/7.77/198%
 
@@ -153,5 +167,5 @@
 
 B.2/ Multiplication de matrices mtx = mtx1 * mtx2 
-
+     ~ 2  10^9 op. double / thread
 (1) time cpupower 2  (-O3 / -O -g)
 (2) time zthr mtx 1 1000   1 thread
@@ -192,5 +206,5 @@
                                            (6) 50.1/18.15/276%
 
-(f)G4-osx-1.25GHz      333        
+(f)G4-osx-1.25GHz      333        23.5/24.5/96%                              [-O2]
 (h)G5-osx-1GHz        1151        23/23.7/97%                46.5/27.5/170%
                                            (4) 93.4/49.4/189%
@@ -244,5 +258,6 @@
 (f)superosf            842        6./6.22/96.7%      166        5.1/5.18/97.4%    196     
 
-(f)G4-osx-1.25GHz      333        15.2/15.9/96%       66        23.8/34.1/70%     42
+(f)G4-osx-1.25GHz       92        15.2/15.9/96%       66        23.8/34.1/70%     42    [-g]
+                       380        8.8/10.3/86%                  14.7/20.9/65%           [-O2 -g]
 (h)G5-osx-1GHz        1151        8.5/8.7/97.5%      120        11.5/11.6/99%     87
     -tune=G5                      5/5.1/98%          200        5.5/5.6/97%       180
@@ -279,5 +294,5 @@
 (f)superosf           
 
-(f)G4-osx-1.25GHz 
+(f)G4-osx-1.25GHz          2.3/~100%   [-O2 -g]
 (h)G5-osx-1GHz             0.8/~100%
     -tune=G5            
@@ -312,5 +327,6 @@
 (e)superosf (1)          
 (
-(f)G4-osx-1.25GHz (1)    40.5/42.6/95%    42.2/43.5/97%   
+(f)G4-osx-1.25GHz (1)    40.5/42.6/95%    42.2/43.5/97%      [-g]
+                          3.9/4.3/89%      3.5/4/89%       3.8/4/95%         4.3/4.6/93%
 
 (h)G5-osx-1GHz (2)     2.6/130% (NoThSafe)                   
@@ -347,5 +363,5 @@
 (f)superosf           
 
-(f)G4-osx-1.25GHz 
+(f)G4-osx-1.25GHz          26/29.7/87%     15.7/38.6/41%               [-O2 -g]
 (h)G5-osx-1GHz 
     -tune=G5            