Index: trunk/SophyaLib/Manual/perfmachine.txt
===================================================================
--- trunk/SophyaLib/Manual/perfmachine.txt	(revision 3250)
+++ trunk/SophyaLib/Manual/perfmachine.txt	(revision 3251)
@@ -43,7 +43,57 @@
 - Sur machine aix-meso [-O -g] ou [-O3 -g]
 
-X/ Donnees SPECint2000 (3) / SPECfp2000 (2) (http//www.spec.org)
-
-(1) MFLOPS  -> cpupower 2   (x/y : -O -g / -O3)  
+X/ Performances brutes cpupower et donnees SPEC ((http//www.spec.org) 
+----------------------------------------------------------------------
+
+(1) MFLOPS  -> cpupower 2   (x/y : -O -g / -O3) 
+SPECint2000 (3) / SPECfp2000 (2) (http//www.spec.org) 
+
+csh> cpupower 0 3000000  5 
+     3 10^6 operations doubles - sur memoire 3x3 10^6 doubles (~50 MO)
+      ===> ~ 24 MO / MFLOPS
+csh> cpupower 2
+     1.6 10^9 operations doubles - sur 3x20000 doubles (~0.5 MO)
+
+
+Compilation avec -O  (optimisation)
+  (1) cpupower 0 : debit memoire en MO/s
+  (2) cpupower 0  , MFLOPS   
+  (5) cpupower 2 ,  MFLOPS 
+
+Compilation avec -g (debug / sans optimisation)
+  (3) cpupower 0  , MFLOPS  
+  (6) cpupower 2  , MFLOPS 
+
+Compilation avec -O3 ou -fast ...( optimisation poussee) 
+  (4) cpupower 0  , MFLOPS  
+  (7) cpupower 2  , MFLOPS 
+
+
+(3) cc -O   /  cc -g1 -O 
+(4) cc -O3 
+
+csh>  cpupower 2 
+
+----------------------------------------------------------------------------------------------
+        MFLOPS       |(1) MO/s|   (2)     (3)      (4)   |    (5)       (6)       (7)      
+----------------------------------------------------------------------------------------------
+(a)xeon-lx-2.4GHz    | 1290   |   53      53       55    |    338       340       320
+(a)xeon-lx-2.8GHzicc | 1560   |   65      62       60    |    914       409       914
+(c)amd-lx            | 2280   |   95      77       97    |    666       314       686 
+(cc)amd2-lx          |        |
+
+(e')osf-cool         |  768   |   32      15       32    |    630       150       660     
+(f)superosf               
+
+(g)G5-osx-1 GHz      | 2100   |   88      68       88    |   1000       255      1073
+(f)G4-osx-1.25GHz    |  600   |   25      16       25    |    417        93       430 
+(i)core-osx-1.83GHz  |        |
+(j)xeon-osx            
+
+(p)ibm-aix-regatta    
+(p)ibm-aix-meso      | 3600   |  150      75      150    |   1480       203      3600
+----------------------------------------------------------------------------------------------
+
+csh  cpupower 2 
 ----------------------------------------------------------------------
                          MFLOPS(1)      SPECfp      SPECint 
@@ -53,5 +103,5 @@
 (cc)amd2-lx               675            1600        1300
 
-(d)osf-xp1000             648             500         400
+(e)osf-xp1000             648             500         400
 (f)superosf               842            1100         700
 
@@ -88,8 +138,9 @@
 (f)superosf (1)          895 s      112       910 s        98%
 
-(f)G4-osx-1.25GHz (1)    660 s      151       710 s        93%   [-g]
+(g)G5-osx-1GHz (2)       453 s      221       250 s        182%
+    -tune=G5            1100 s       90
+    -g -O                740 s                380 s        195%
+(h)G4-osx-1.25GHz (1)    660 s      151       710 s        93%   [-g]
                         1500 s                             94%   [-O2 -g]
-(h)G5-osx-1GHz (2)       453 s      221       250 s        182%
-    -tune=G5            1100 s       90
 (i)core-osx-1.83GHz (2)  209 s      478       116 s        180%
               -O2   (1)  367 s      272       381          96%    
@@ -100,7 +151,8 @@
 
 Taille shared libs : 
-(a) 
+(a)
+(c) 33 MO   
 (f) = (e) = 57 MO 
-(h) 80 MO
+(g) 80 MO
 (i) 83 MO
 
@@ -139,9 +191,13 @@
                                            (4)11.6/3.06/379%          
 
-(f)G4-osx-1.25GHz       92        44s/48s/91%              86.7/99.8/92%  [-g]
+(h)G4-osx-1.25GHz       92        44s/48s/91%              86.7/99.8/92%  [-g]
                        380        12.2/12.9/95%            24/25.3/95%    [-O2 -g]                   
-(h)G5-osx-1GHz        1151        20s/20s/99%              40s/23s/170%
+(g)G5-osx-1GHz        1151        20s/20s/99%              40s/23s/170%
                                            (4) 80.8/45/180%
+   -O -g                          4.5/4.9/91%              9.3/4.7/197%
+                                           (4) 18.3/9.4/197%
    -tune=G5                       3.35/3.8/88%             7.1/3.6/196%
+(h)G4-osx-1.25GHz       92        44s/48s/91%              86.7/99.8/92%  [-g]
+                       380        12.2/12.9/95%            24/25.3/95%    [-O2 -g]                   
                                            (4) 14/7.5/187%
 (i)core-osx-1.83GHz    855        11.5/11.5/100%           23/11.6/192%   [-g]
@@ -206,10 +262,12 @@
                                            (6) 50.1/18.15/276%
 
-(f)G4-osx-1.25GHz      333        23.5/24.5/96%                              [-O2]
-(h)G5-osx-1GHz        1151        23/23.7/97%                46.5/27.5/170%
+(g)G5-osx-1GHz        1151        23/23.7/97%                46.5/27.5/170%
                                            (4) 93.4/49.4/189%
+  -O -g                           6.2/6.2/100%                14.2/7.2/197%
+                                           (4) 28.3/14.36/197%
   -tune=G5                        5.7/5.8/98%                13.3/6.8/197%
                                            (4) 26.8/13.56/197%
                                            (6) 53.8/27.25/197%
+(h)G4-osx-1.25GHz      333        23.5/24.5/96%                              [-O2]
 (i)core-osx-1.83GHz    855        12.6/12.7/100%             25.8/13.4/194% 
                                            (4) 51.6/26/199%
@@ -258,8 +316,9 @@
 (f)superosf            842        6./6.22/96.7%      166        5.1/5.18/97.4%    196     
 
-(f)G4-osx-1.25GHz       92        15.2/15.9/96%       66        23.8/34.1/70%     42    [-g]
+(g)G5-osx-1GHz        1151        8.5/8.7/97.5%      120        11.5/11.6/99%     87
+    -O -g                         5.1/5.2/98%        190        5.4/5.5/99%       180
+    -tune=G5                      5/5.1/98%          200        5.5/5.6/97%       180
+(h)G4-osx-1.25GHz       92        15.2/15.9/96%       66        23.8/34.1/70%     42    [-g]
                        380        8.8/10.3/86%                  14.7/20.9/65%           [-O2 -g]
-(h)G5-osx-1GHz        1151        8.5/8.7/97.5%      120        11.5/11.6/99%     87
-    -tune=G5                      5/5.1/98%          200        5.5/5.6/97%       180
 (i)core-osx-1.83GHz    855        4.6/4.75/97%       217        7/7.08/99%        142
          -O2                      3.2/3.2/99%        312        3.6/3.6/99%       277
@@ -296,5 +355,5 @@
 (f)G4-osx-1.25GHz          2.3/~100%   [-O2 -g]
 (h)G5-osx-1GHz             0.8/~100%
-    -tune=G5            
+    -O -g                  0.86/~100%            
 (i)core-osx-1.83GHz        1.93/~100%
               -O2   
@@ -326,10 +385,11 @@
 (e')cool                 1.3/1.37/95%     1.35/1.5/89%     5.3/5.3/99%       5.2/5.2/99%    
 (e)superosf (1)          
-(
-(f)G4-osx-1.25GHz (1)    40.5/42.6/95%    42.2/43.5/97%      [-g]
+
+
+(g)G5-osx-1GHz (2)     2.6/130% (NoThSafe)                   
+    -O -g                2.6/1.7/150%      6.8/3.7/187%    4/2.75/142%       4.7/3/155%
+(h)G4-osx-1.25GHz (1)    40.5/42.6/95%    42.2/43.5/97%      [-g]
                           3.9/4.3/89%      3.5/4/89%       3.8/4/95%         4.3/4.6/93%
 
-(h)G5-osx-1GHz (2)     2.6/130% (NoThSafe)                   
-    -tune=G5            
 (i)core-osx-1.83GHz      7.7/7.1/108%     7.8/6.7/116%    30.2/29.6/102%    30.3/29.2/104%   [-g]
               -O2        2.7/1.8/152%     6/3.16/190%     3.4/2.4/142%      3.2/2.5/164%     [-O2 -g]
@@ -363,7 +423,7 @@
 (f)superosf           
 
-(f)G4-osx-1.25GHz          26/29.7/87%     15.7/38.6/41%               [-O2 -g]
-(h)G5-osx-1GHz 
-    -tune=G5            
+(g)G5-osx-1GHz             14/14.2/98%     6/6.14/99% 
+
+(h)G4-osx-1.25GHz          26/29.7/87%     15.7/38.6/41%               [-O2 -g]
 (i)core-osx-1.83GHz        37/37.8/98%     22/48.4/45%                                 [-g]
               -O2          10.5/17.4/55%   11.2/41.2/27%                               [-O2 -g]