Index: trunk/SophyaLib/Manual/perfmachine.txt
===================================================================
--- trunk/SophyaLib/Manual/perfmachine.txt	(revision 3251)
+++ trunk/SophyaLib/Manual/perfmachine.txt	(revision 3254)
@@ -91,5 +91,5 @@
 (j)xeon-osx            
 
-(p)ibm-aix-regatta    
+(p)ibm-aix-regatta   | 3100   |  130      55      133    |    730       115      1750
 (p)ibm-aix-meso      | 3600   |  150      75      150    |   1480       203      3600
 ----------------------------------------------------------------------------------------------
@@ -160,5 +160,57 @@
 --------------------------------------------------------
 
-B.1/ arr = c1*a1+c2*a2   ( ~ 3 10^6 op. double)
+B.1/ Version corrige de zthr.cc (apres 23/05/07) 
+         arr = (c1*a1) + (c2*a2) 
+         ~ 3 x 4. 10^6 operations int_4 sur 3 x 4 10^6 int_4    
+         12 M.Ops int_4 / ~ 50 MO 
+
+(1) time cpupower 0     # compile avec -O  (/ -O -g)
+(2) time zthr arr 1 2000   1 thread
+(3) time zthr arr 2 2000   2 thread
+(4) time zthr arr 4 2000   4 thread
+(5) time zthr arr 6 2000   6 thread
+(6) time zthr arr 8 2000   8 thread
+
+-----------------------------------------------------------------------------------
+                     (1)MFLOPS  (2)CPU/Elap/%   (3)CPU/Elap/%   (4)CPU/Elap/%
+-----------------------------------------------------------------------------------
+(a)xeon-lx-2.4GHz      53        0.5/1/43%      1/1.1/88%      2.8/1/262%
+                                    (5) 4.5/1.8/246%      (6) 6.1/2.1/310% 
+                                  
+        
+(b)xeon-lx-2.8GHz      65        
+                                  
+(c)amd-lx              95        0.23/1/22%     0.44/1/51%       1/1/102%     [-O -g]
+                                     (5) 1.6/1/106%   (6) 2.2/1.2/100% 
+
+
+(d)osf-asc                     
+                                  
+(e')osf-cool           32        0.43/1.2/35%   0.6/1.33/44%     1.1/1.3/82%      [-O -g]
+                                     (5) 1.45/1.7/85%   (6) 1.83/2.16/84%         
+(f)superosf                    
+
+(g)G5-osx-1GHz         88       1.5/1.5/100%    3.2/1.7/185%      6.6/3.5/188%    [-O -g]
+(g)G5-osx-1GHz         88       0.4/1/40%       0.9/1.0/90%       2/1.2/169%      [-tune=G5 -g]
+                                     (5) 3.3/2/164%    (6) 4.3/2.6/165%
+(h)G4-osx-1.25GHz      25       3/3/95%                                           [-O2 -g]
+                                  
+(i)core-osx-1.83GHz               [-O2 -g]
+
+(j)xeon-osx           
+
+
+(p)ibm-aix-regatta   130        
+
+(q)ibm-aix-meso      150        0.6/1/58%       1/1/91%           1.7/1.2/132%    [-O3]
+                                     (5) 2.4/1.2/193%   (6) 4.25/1.6/265%      
+
+
+(s)sgi-magique         460        
+ -----------------------------------------------------------------------------------
+
+B.1.bis/ ancienne version de zthr (avant 23/05/07) 
+         On faisait 2 multiplications par ctye suivi d'un produit matriciel !
+         arr = c1*a1*c2*a2   ( ~ 3 10^6 op. double)
 (1) time cpupower 2     # compile avec -O3  (/ -O -g)
 (2) time zthr arr 1 1000   1 thread
@@ -291,4 +343,44 @@
  -----------------------------------------------------------------------------------
 
+
+B.4/ Operations sur tableaux doubles- mesures avec spar 
+  csh> time spar 2 1 2000 2000
+  (1) cpupower 2  MFLOPS
+  (2) MFLOPS (double) spar 
+  (3) time spar 2 5 1000 2000 CPU/Elap/% 
+-----------------------------------------------------------------------------------
+                     (1)MFLOPS      (2)CPU / %         (3)CPU/Elap/%
+-----------------------------------------------------------------------------------
+(a)xeon-lx-2.4GHz      53       ~ 20-35 MFLOPS , 90%     20/20.2/99%       [-g -O] 
+                                  
+        
+(b)xeon-lx-2.8GHz      65        
+                                  
+(c)amd-lx              95       ~ 20-40 MFLOPS , 99%     17.2/17.2/100%    [-g -O] 
+
+
+(d)osf-asc                     
+                                  
+(e)osf-xp1000          32       ~ 15-25 MFLOPS , 90%     37.6/41.2/91%      [-g -O]  
+(f)superosf                    
+
+(g)G5-osx-1GHz         88       ~ 10-25 MFLOPS , 99%     45/45/100%         [-g -O] ou [-g -O2]
+(h)G4-osx-1.25GHz      25       ~ 8-16  MFLOPS , 92%     45.5/52/90%        [-g -O2]
+                                  
+(i)core-osx-1.83GHz             
+
+(j)xeon-osx           
+
+
+(p)ibm-aix-regatta   130        
+
+(q)ibm-aix-meso      150        ~ 80-100 MFLOPS , 90%   5./23/22%     [-O3]    
+
+
+
+(s)sgi-magique         460        
+ -----------------------------------------------------------------------------------
+
+
 C/ Calcul fft (FFTW , FFTPack )
 -------------------------------