Index: trunk/SophyaLib/Manual/perfmachine.txt
===================================================================
--- trunk/SophyaLib/Manual/perfmachine.txt	(revision 3254)
+++ trunk/SophyaLib/Manual/perfmachine.txt	(revision 3258)
@@ -49,4 +49,5 @@
 SPECint2000 (3) / SPECfp2000 (2) (http//www.spec.org) 
 
+X.1/ Performances en calcul double
 csh> cpupower 0 3000000  5 
      3 10^6 operations doubles - sur memoire 3x3 10^6 doubles (~50 MO)
@@ -70,15 +71,10 @@
 
 
-(3) cc -O   /  cc -g1 -O 
-(4) cc -O3 
-
-csh>  cpupower 2 
-
 ----------------------------------------------------------------------------------------------
         MFLOPS       |(1) MO/s|   (2)     (3)      (4)   |    (5)       (6)       (7)      
 ----------------------------------------------------------------------------------------------
 (a)xeon-lx-2.4GHz    | 1290   |   53      53       55    |    338       340       320
-(a)xeon-lx-2.8GHzicc | 1560   |   65      62       60    |    914       409       914
-(c)amd-lx            | 2280   |   95      77       97    |    666       314       686 
+(a)xeon-lx-2.8GHzicc | 2040   |   85      80       83    |    914       409       914
+(c)amd-lx            | 1560   |   65      77       68    |    666       314       686 
 (cc)amd2-lx          |        |
 
@@ -88,5 +84,5 @@
 (g)G5-osx-1 GHz      | 2100   |   88      68       88    |   1000       255      1073
 (f)G4-osx-1.25GHz    |  600   |   25      16       25    |    417        93       430 
-(i)core-osx-1.83GHz  |        |
+(i)core-osx-1.83GHz  | 2500   |  107      75      107    |    855       309       884
 (j)xeon-osx            
 
@@ -95,5 +91,37 @@
 ----------------------------------------------------------------------------------------------
 
-csh  cpupower 2 
+X.2/  Comparaison performances int, float double 
+  cpupower compile avec -O 
+
+(1) float , cpupowerF 0 3000000 5 / cpupowerF 2
+    -> MFLOPS (puissance de calcul sur float)
+(2) double, cpupowerD 0 3000000 5 / cpupowerF 2  (idem tableau X.1)
+    -> MDBLOPS (puissance de calcul sur float)
+(3) int, cpupowerI 0 3000000 5 / cpupowerI 2
+    -> MINTOPS  (puissance de calcul sur int)
+(4) long (ou long long (*)) cpupowerL 0 3000000 5 / cpupowerL 2
+    -> MLONOPS  (puissance de calcul sur long)
+----------------------------------------------------------------------------------------------
+        MFLOPS       |   (1)MFLOPS       (2)MDBLOPS       (3)MINTOPS       (4)MLONOPS 
+----------------------------------------------------------------------------------------------
+(a)xeon-lx-2.4GHz    | 
+(a)xeon-lx-2.8GHzicc |    166/905         90/900           166/1500         88/522    (*)
+(c)amd-lx            |    125/695         65/675           125/1570         65/1045
+(cc)amd2-lx          | 
+
+(e')osf-cool         | 
+(f)superosf               
+
+(g)G5-osx-1 GHz      | 
+(f)G4-osx-1.25GHz    | 
+(i)core-osx-1.83GHz  |    185/919         105/855           187/935         62/246
+(j)xeon-osx            
+
+(p)ibm-aix-regatta   | 
+(p)ibm-aix-meso      |    250/628         160/1260          240/1120        
+----------------------------------------------------------------------------------------------
+
+X.3/  Comparaison avec SPEC 
+csh>  cpupower 2 
 ----------------------------------------------------------------------
                          MFLOPS(1)      SPECfp      SPECint 
@@ -382,4 +410,23 @@
  -----------------------------------------------------------------------------------
 
+B.5/  Calcul/comparaison avec JET/tjet 
+csh> time tjet 10 2000 2000   OU tjet 10 2000 1000
+ (1) TCPU EltAccess C/pointeurs 
+ (2) TCPU m1*c1+m2*c2+m3*c3 C/pointeurs 
+ (3) TCPU EltAccess  SOPHYA
+ (4) TCPU m1*c1+m2*c2+m3*c3 SOPHYA  / Methodes
+ (5) TCPU m1*c1+m2*c2+m3*c3 SOPHYA JET
+
+ -----------------------------------------------------------------------------------
+                            (1)        (2)         (3)         (4)           (5)             
+ -----------------------------------------------------------------------------------
+(b)xeon-lx-2.8GHz-icc       0.87       0.63        1.55      2.7/1.6         0.57
+(c)amd-lx                   0.94       0.79        1.85      3.4/2.1         0.76
+
+(i)core-osx-1.83GHz         1.1        0.49        1.6       2.8/1.7         0.68
+
+(q)ibm-aix-meso             0.43       0.27        0.52      1.12/0.75       0.35  
+-----------------------------------------------------------------------------------
+
 
 C/ Calcul fft (FFTW , FFTPack )
@@ -524,2 +571,5 @@
 
 --------------------------------------------------------------------------------------------
+
+
+